futhark-0.25.32: An optimising compiler for a functional, array-oriented language.

Safe Haskell | None
Language | GHC2021

Futhark.CodeGen.ImpGen.GPU.SegMap

Description

Code generation for `SegMap` is quite straightforward. The only trick is virtualisation in case the physical number of threads is not sufficient to cover the logical thread space. This is handled by having actual threadblocks run a loop to imitate multiple threadblocks.

Synopsis

- compileSegMap :: Pat LetDecMem -> SegLevel -> SegSpace -> KernelBody GPUMem -> CallKernelGen ()

# Documentation

compileSegMap :: Pat LetDecMem -> SegLevel -> SegSpace -> KernelBody GPUMem -> CallKernelGen () Source #

Compile `SegMap` instance code.